diff -r accc14b26ef3 gdk/gdk_heap.c
--- a/gdk/gdk_heap.c	Tue Sep 20 16:10:42 2016 +0200
+++ b/gdk/gdk_heap.c	Tue Sep 20 18:17:03 2016 +0200
@@ -99,11 +99,11 @@
 		GDKerror("HEAPalloc: allocating more than heap can accomodate\n");
 		return GDK_FAIL;
 	}
-	if (h->filename == NULL || h->size < GDK_mmap_minsize) {
-		h->storage = STORE_MEM;
-		h->base = (char *) GDKmallocmax(h->size, &h->size, 0);
-		HEAPDEBUG fprintf(stderr, "#HEAPalloc " SZFMT " " PTRFMT "\n", h->size, PTRFMTCAST h->base);
-	}
+
+	h->storage = STORE_MEM;
+	h->base = (char *) GDKmallocmax(h->size, &h->size, 0);
+	HEAPDEBUG fprintf(stderr, "#HEAPalloc " SZFMT " " PTRFMT "\n", h->size, PTRFMTCAST h->base);
+
 	if (h->filename && h->base == NULL) {
 		char *nme, *of;
 		struct stat st;
@@ -206,7 +206,7 @@
 		Heap bak = *h;
 		size_t cur = GDKmem_cursize(), tot = GDK_mem_maxsize;
 		int exceeds_swap = size > (tot + tot - MIN(tot + tot, cur));
-		int must_mmap = h->filename != NULL && (exceeds_swap || h->newstorage != STORE_MEM || size >= GDK_mmap_minsize);
+		int must_mmap = h->filename != NULL && (exceeds_swap || h->newstorage != STORE_MEM);
 
 		h->size = size;
 
